#!/bin/bash


cas=eurocs_Cu


var=$1



#########################################################################################

if [ $cas = eurocs_Cu ] ; then

cat <<eod>| vars.def
ovap    1000*Eau_tot/(1000+Eau_tot)             1000.   Hum.specif.(g/kg)        0.:20.
thetav  Theta*(1.+0.00061*(Eau_tot-Eau_liq))    1.   Tempe.pot.virtuelle.(K)  303.:320.
theta   Theta                                   1.   Tempe.virtuelle.(K)       299.:320.
rhum    Rhum                                    1.   Hum.relative.(%)          0.:1.
vitu    vitu,vitv                               1.   vent.(m/s)                 -3.:11.:1.
eod

heure=( 13h30 17h30 20h30 )
TSTEP=30
# indices des pas de temps pour le modele
tstep=( `echo $TSTEP | awk ' { print 120*60/$1 , 360*60/$1 , 540*60/$1 } '` ) 

else

cat <<eod>| vars.def
ovap    qv                                   1000.   Hum.specif.(g/kg)        0.:20.
thetav  Theta*(1.+0.00061*(Eau_tot-Eau_liq))    1.   Tempe.pot.virtuelle.(K)  303.:320.
theta   theta                                   1.   Tempe.virtuelle.(K)       298.:310.
rhum    Rhum                                    1.   Hum.relative.(%)          0.:1.
vitu    vitu,vitv                               1.   vent.(m/s)                 -3.:11.:1.
rneb    a                                       1.   Couvert.nuages          0.:0.3
eod
heure=( 2h30 4h30 5h30 )
tstep=( 13:36@AVE 49:60@AVE 61:72@AVE )

fi










echo toto
ligne=`grep '^'$var' ' vars.def`
varles=`echo $ligne | awk ' { print $2 } '`
fact=`echo $ligne | awk ' { print $3 } '`
nomvar=`echo $ligne | awk ' { print $4 } '`
hlim=`echo $ligne | awk ' { print $5 } '`


echo $varles
echo $fact
echo $nomvar
echo $varles
echo hlim=$hlim

#########################################################################################
#########################################################################################



graph=( ul ur ll )
hmax=( 2400 2400 3400 )


models=( "RIO2007"  THER0 THER    )
hists=( histmth_G95__L40_30s_ther.nc )


colsim=( red green blue purple )



#########################################################################################
# Ouverture des fichiers
#########################################################################################
\rm tmp.jnl ; touch tmp.jnl


for isim in ${!hists[*]} ; do
cat <<eod>> tmp.jnl
use "${hists[$isim]}"
eod
done

cat <<eod>> tmp.jnl
alias WAITING MESSAGE
def axis/z/from_data/unit=m/name=geopot_ax geop[l=1]/9.8
eod

set mode metafile page.plt
#------------------------------------------------------------------

thicksimu=2


#########################################################################################
# Boucle sur les graphiques (pour chaque heure)
#########################################################################################

for igr in 0 1 2 ; do

vartrace="$fact*$var[l=${tstep[$igr]},gz=geopot_ax@asn]"
limits="hlimits=$hlim/vlimits=0:${hmax[$igr]}:100"

cat <<eod>> tmp.jnl
set viewport ${graph[$igr]}
plot/title="$nomvar a ${heure[$igr]}"/color=red/thick=$thicksimu/$limits/d=1 $vartrace
eod



######################################################################################################
# Boucle sur les simulations
######################################################################################################
for isim in ${!hists[*]} ; do

((ddd=$isim + 1))
if [ $var = vitu ] ; then
cat <<eod>> tmp.jnl
plot/over/color=${colsim[$isim]}/thick=$thicksimu/title="${models[$isim]}"/d=$ddd vitu[l=${tstep[$igr]},gz=geopot_ax@asn]
plot/over/color=${colsim[$isim]}/thick=$thicksimu/nolabel/d=$ddd vitv[l=${tstep[$igr]},gz=geopot_ax@asn]
eod
else
cat <<eod>> tmp.jnl
plot/over/color=${colsim[$isim]}/thick=$thicksimu/title="${models[$isim]}"/d=$ddd  $vartrace
eod
fi


done

######################################################################################################
# Tracer pour les LES cas EUROCS
######################################################################################################

if [ $cas = eurocs_Cu ] ; then

hhh=`echo ${heure[$igr]} | sed -e 's/h30$/30/'`
if [ $var = vitu ] ; then
cat <<eod>> tmp.jnl
file/var="HH,Vitu,Vitv,Theta,Temp,Eau_tot,Eau_liq,Rsat,Rhum,Dens" "resul_LES/A_$hhh.DAT"
plot/title="LES"/vs/line=1/over vitu,HH
plot/nolabel/vs/line=1/dash/over vitv,HH
file/var="HH,Vitu,Vitv,Theta,Temp,Eau_tot,Eau_liq,Rsat,Rhum,Dens" "resul_LES/KNMI_INITIAL.DAT"
plot/nolabel/vs/line=1/dash/over vitu,HH
plot/nolabel/vs/line=1/dash/over vitv,HH
eod
else
cat <<eod>> tmp.jnl
file/var="HH,Vitu,Vitv,Theta,Temp,Eau_tot,Eau_liq,Rsat,Rhum,Dens" "resul_LES/A_$hhh.DAT"
plot/title="LES"/vs/line=1/over $varles,HH
file/var="HH,Vitu,Vitv,Theta,Temp,Eau_tot,Eau_liq,Rsat,Rhum,Dens" "resul_LES/KNMI_INITIAL.DAT"
plot/nolabel/vs/line=1/dash/over $varles,HH
eod
fi

######################################################################################################
# Tracer pour les LES cas BOMEX
######################################################################################################

else

hhh=`echo ${heure[$igr]} | sed -e 's/h30$/.30/'`
cat <<eod>> tmp.jnl
file/var="$varles,zz" "resul_LES/$varles.$hhh"
plot/title="LES"/over/vs/line=1 $varles,zz
eod
fi
######################################################################################################

done

cat <<eod>> tmp.jnl
frame/file=$var.gif
quit
eod


\rm $var.gif

ferret -gif -nojnl  <<eod
go tmp.jnl
quit
eod

if [ -f $var.gif ] ; then
display $var.gif
else
echo Probleme a l execution
fi
