#!/bin/bash

listecas=" 24B 00WC 05WC 00SC 03SC  05SC  24SC  24F 15B "
#listecas=" 24SC "


# nombres de couches pour les post-traitments
zmax=85000.

SIM=$1

if [ ! -d $SIM ] ; then
echo $SIM n existe pas
exit
fi
cd $SIM


####################################################################
#  DEBUT DE LA BOUCLE SUR LES CAS
####################################################################

div=1

for cas in $listecas ; do

descr=`grep $cas ../description`
wt0=`echo $descr | awk ' { print $2 } '`
Ug=`echo $descr | awk ' { print $3 } '`
Vg=`echo $descr | awk ' { print $4 } '`
t0=`echo $descr | awk ' { print $5 } '`
t1=`echo $descr | awk ' { print $6 } '`
dt=`echo $div $descr | awk ' { print $8 / $1 } '`
echo $div $descr $dt
ustar=`echo $descr | awk ' { print $8 } '`
dtstock=`echo $descr | awk ' { print $7 } '`

# dtstock est le pas de temps du fichier histoire utilise
dtstock=50

npasday=`echo $dt | awk ' { print 86400 / $1 } '`
npas=`echo $dt | awk ' { print '$t1' / $1 } '`

npasday=`echo $dt | awk ' { print 86400 / '$dtstock' } '`
npas=`echo $dt | awk ' { print '$t1' / '$dtstock' } '`

echo $cas $npas $t1
cd $cas

ln -s  ../../DONNEES/LES$cas/t0.a data
nsor=`echo $npasday | awk ' { print $1 / '$div' } '`
pas0=`echo $dtstock | awk ' { print '$t0' / $1 + 1 } '`
echo $cas $wt0 $Ug $t0 $t1 $dt $npasday $pas0 $npas

#   Choix entre une moyenne temporelle ou la valeur medaine comme
#   valeur finale.

if [ 1 == 0 ] ; then
pas1=`echo $pas0 $npas | awk ' { print ( $1 + $2 ) / 2. } '`
pas2=$pas1
else
pas1=$pas0
pas2=`echo $npas | awk ' { print $1 / '$div' } '`
fi
pas1=`echo $dtstock | awk ' { print int( '$t0' / $1 ) +1 } '`
pas2=`echo $dtstock | awk ' { print int( '$t1' / $1  ) } '`
echo $pas1 $pas2


echo $cas PAS1 $pas1 PAS2 $pas2


###########################
# Extraction des champs 1D.
###########################
../../extractnc.x vitv $pas1 $pas2 $zmax vm
../../extractnc.x $npasday'*(wtajs+wtvdf)' $pas1 $pas2 $zmax  wtm
../../extractnc.x theta $pas1 $pas2 $zmax tm
../../extractnc.x theta 1 1 $zmax t0m
mv tmp.jnl tmpemp.jnl
../../extractnc.x trac01 $pas1 $pas2 $zmax bm
../../extractnc.x trac02 $pas1 $pas2 $zmax cm
../../extractnc.x vitu $pas1 $pas2 $zmax um
echo ../../extractnc.x vitu $pas1 $pas2 $zmax um
for f in t0 u0 v0 b0 c0 ; do
\cp ../../DONNEES/LES$cas/$f $f
done





data=../../DONNEES/LES$cas

\rm -r vent.epsi temp.epsi flux.epsi
xmgrace="xmgrace -legend load"
$xmgrace -view 0.15 0.15 0.85 0.85 -hardcopy -printfile vent.ps um vm $data/um $data/vm $data/u0 $data/v0
$xmgrace -view 0.15 0.15 0.55 0.85 -hardcopy -printfile temp.ps t0m tm $data/tm $data/t0
$xmgrace -view 0.15 0.15 0.35 0.85 -hardcopy -printfile B.ps bm $data/bm $data/b0
$xmgrace -view 0.15 0.15 0.35 0.85 -hardcopy -printfile C.ps cm $data/cm $data/c0
$xmgrace -view 0.15 0.15 0.55 0.85 -hardcopy -printfile flux.ps wtm $data/wtm

for i in vent temp B C flux ; do
ps2epsi $i.ps
done

pwd
cd ..

echo $cas
echo $listecas

done

