      SUBROUTINE add_pbl_tend (zdu,zdv,zdt,zdq,zdql,text)
!======================================================================
! Ajoute les tendances de couche limite, soit determinees par la parametrisation
! physique, soit forcees,  aux variables d etat de la dynamique t_seri, q_seri ...
!======================================================================


!======================================================================
! Declarations
!======================================================================

      use dimphy
      use phys_local_var_mod
      use phys_state_var_mod
      IMPLICIT none
#include "dimensions.h"
        real  hthturb_gcssold(llm)
        real  hqturb_gcssold(llm)
        real dtime_frcg
        logical  Turb_fcg_gcssold
        common /turb_forcing/ dtime_frcg,
     $           Turb_fcg_gcssold, hthturb_gcssold, hqturb_gcssold
! Arguments :
!------------
      REAL zdu(klon,klev),zdv(klon,klev)
      REAL zdt(klon,klev),zdq(klon,klev),zdql(klon,klev)
      CHARACTER*(*) text

! Local :
!--------
      REAL zzdt(klon,klev),zzdq(klon,klev)
      INTEGER i,k
!
      IF (Turb_fcg_gcssold) THEN
       DO k = 1,klev
        DO i = 1,klon
         zzdt(i,k) = hthturb_gcssold(k)*dtime_frcg
         zzdq(i,k) = hqturb_gcssold(k)*dtime_frcg
        ENDDO
       ENDDO
       print *,' add_pbl_tend, dtime_frcg ', dtime_frcg
       print *,' add_pbl_tend, zzdt ', zzdt
       print *,' add_pbl_tend, zzdq ', zzdq
       CALL add_phys_tend (zdu,zdv,zzdt,zzdq,zdql,text)
      ELSE
       CALL add_phys_tend (zdu,zdv, zdt, zdq,zdql,text)
      ENDIF
!

      RETURN
      END
